(define-module (ui net-openvpn ajax)
			   :use-module (alterator ajax)
			   :use-module (alterator woo)
			   :export (init))

(define (read-connections)
  (form-update-enum "connections" (woo-list "/net-openvpn/avail_connections")))

(define (read-config)
  (let ((cmd (woo-read-first "/net-openvpn"
							 'dev (form-value "connections") 'language (form-value "language"))))
	(form-update-enum "keys" (woo-list "/net-openvpn/avail_keys"))
	(form-update-value-list
	  ;     '("server" "port" "ca" "cert" "key")
	  '("server" "port" "keys")
	  cmd)))

(define (update-interface)
  (read-config)
  (read-connections)
  (form-update-value "dev_type" "tun"))

(define (write-config)
  (catch/message
	(lambda()
	  (apply woo-write
			 "/net-openvpn"
			 'commit #t
			 'dev (form-value "connections")
			 (form-value-list
			   ;          '("server" "port" "ca" "cert" "key"))))))
			   '("server" "port" "keys"))))))

(define (new-connection)
  (and
	(catch/message
	  (lambda()
		(woo-write
		  "/net-openvpn"
		  'new #t
		  'dev_type (form-value "dev_type"))))
	(read-connections)))

(define (delete-connection)
  (and
	(catch/message
	  (lambda()
		(woo-write
		  "/net-openvpn"
		  'delete #t
		  'dev (form-value "connections"))))
	(read-connections)))

(define (disconnect)
  (and
	(catch/message
	  (lambda()
		(woo-write
		  "/net-openvpn"
		  'disconnect #t
		  'dev (form-value "connections"))))))

(define (create-req)
  (catch/message
	(lambda()
	  (woo-write
		"/net-openvpn"
		'create_req #t
		'CN (form-value "CN")))))

(define (init)
  (update-interface)
  (form-bind "new_connection" "click" new-connection)
  (form-bind "connections" "change" read-config)
  (form-bind "create_req" "click" create-req)
  (form-bind "apply" "click" write-config)
  (form-bind "delete" "click" delete-connection)
  (form-bind "disconnect" "click" disconnect))

