(document:surround "/std/frame")

;;; Functions

(define (read-connections)
  (form-update-enum "connections" (woo-list "/net-openvpn/avail_connections")))

(define (read-config)
  (let ((cmd (woo-read-first "/net-openvpn" 
							 'dev (form-value "connections"))))
	(form-update-enum "keys" (woo-list "/net-openvpn/avail_keys"))
	(form-update-value-list
	  ;	  '("server" "port" "ca" "cert" "key")
	  '("server" "port" "keys")
	  cmd)))

(define (update-interface)
  (read-config)
  (read-connections)
  (form-update-value "dev_type" "tun"))

(define (write-config)
  (catch/message
	(lambda()
	  (apply woo-write
			 "/net-openvpn"
			 'commit #t
			 'dev (form-value "connections")
			 (form-value-list
			   ;		   '("server" "port" "ca" "cert" "key"))))))
			   '("server" "port" "keys"))))))

(define (new-connection)
  (and
	(catch/message
	  (lambda()
		(woo-write
		  "/net-openvpn"
		  'new #t
		  'dev_type (form-value "dev_type"))))
	(read-connections)))

(define (delete-connection)
  (and
	(catch/message
	  (lambda()
		(woo-write
		  "/net-openvpn"
		  'delete #t
		  'dev (form-value "connections"))))
	(read-connections)))

(define (disconnect)
  (and
	(catch/message
	  (lambda()
		(woo-write
		  "/net-openvpn"
		  'disconnect #t
		  'dev (form-value "connections"))))))
;;; UI
(gridbox
  columns "0;100"
  margin 20

  (gridbox
	colspan 2
	columns "0;40;150"

  (listbox name "connections")

  (gridbox
	colspan 2
	columns "0;40;60"
	;;
	;;    (label text (_ "Type: ") name "type" align "right")
	;;    (combobox name "type")
	;;    (spacer)
	;;
	(label text (_ "Server:") name "server" align "right")
	(edit name "server")
	(spacer)

	;;
	(label text (_ "Port:") name "port" align "right")
	(edit name "port")
	(spacer)
	;;
	(label text (_ "Keys:") name "keys" align "right")
	(combobox name "keys")
	(spacer)
	;    (label text (_ "CA Certificate:") name "ca" align "right")
	;    (edit name "ca")
	;    (spacer)
	;    ;;
	;    (label text (_ "User Certificate:") name "cert" align "right")
	;    (edit name "cert")
	;    (spacer)
	;    ;;
	;    (label text (_ "Private Key:") name "key" align "right")
	;    (edit name "key")
	;    (spacer)
	;;
  (hbox align "left"
		colspan 2
		(button (_ "Apply") name "apply")
		(button (_ "Disconnect") name "disconnect")
		(button (_ "Delete") name "delete"))

	)
  (hbox align "left"
		colspan 2
		(button (_ "Apply") name "apply")
		(button (_ "Disconnect") name "disconnect")
		(button (_ "Delete") name "delete"))
  (spacer)
  (separator colspan 2)
  (spacer))

  (label colspan 2 text (bold (_ "New connection:")))
  (gridbox
	colspan 2
	columns "0;40;150"
	(radio name "dev_type" align "left" value "tun" colspan 2 text (_ "Network tunnel (TUN)"))
	(spacer)
	(radio name "dev_type" align "left" value "tap" colspan 2 text (_ "Virtual Ethernet device (TAP)"))
	(spacer)
	(button (_ "Create connection") name "new_connection")
	(spacer)))

;;;;;;;;;;;;;;;;;;

(document:root 
  (when loaded (update-interface))
  (form-bind "new_connection" "click" new-connection)
  (form-bind "connections" "change" read-config)
  (form-bind "apply" "click" write-config)
  (form-bind "delete" "click" delete-connection)
  (form-bind "disconnect" "click" disconnect))

